/*
 *  Nikwi Deluxe
 *  Copyright (C) 2006  Kostas Michalopoulos
 *  
 *  A game by Kostas "Bad Sector" Michalopoulos
 *  email: badsector@slashstone.com
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/*
** Nikwi Engine - Sound
*/

#ifndef __SOUND_H_INCLUDED__
#define __SOUND_H_INCLUDED__

struct Sample
{
	uint		code;
	short		*wave;
	uint		length;
	
	Sample		*next;
};

struct SampleQueueEntry
{
	Sample			*sample;
	uint			pos;
	SampleQueueEntry	*prev;
	SampleQueueEntry	*next;
};

extern bool	noSound;

void initSound();
void shutdownSound();

Sample *findSample(uint code);

void playSample(Sample *sample);

#endif

